#include "FlowLoseLayer.h"
#include "FlowGameLayer.h"
#include "FlowManagement.h"
#include "SimpleAudioEngine.h"
CFlowLoseLayer::CFlowLoseLayer(void)
{
}


CFlowLoseLayer::~CFlowLoseLayer(void)
{
}

bool CFlowLoseLayer::init()
{
    bool bRet=false;
	do 
	{
		CC_BREAK_IF(!CCLayerGradient::initWithColor(ccc4(0,0,0,0),ccc4(250,250,250,0),ccp(0,1)));
		this->initDialog();
		bRet=true;
	} while (0);
	return bRet;
}

void CFlowLoseLayer::initDialog()
{
	CCSize visibleSize = CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin = CCDirector::sharedDirector()->getVisibleOrigin();

	CCSprite *pBGSprite = CCSprite::create("overlayer/black_bg.png");
	pBGSprite->setScale(0.75f);
	pBGSprite->setPosition(ccp(visibleSize.width / 2, visibleSize.height / 2));
	this->addChild(pBGSprite, 1);

	Size bg_size = pBGSprite->getContentSize();

	CCMenuItemImage *pReplay = CCMenuItemImage::create(
		"overlayer/again.png",
		"overlayer/again_1.png",
		this,
		menu_selector(CFlowLoseLayer::replayGame)
	);
	pReplay->setPosition(ccp(bg_size.width / 2, bg_size.height*0.5));
	CCMenuItemImage *pGoMenu = CCMenuItemImage::create(
		"overlayer/back.png",
		"overlayer/back_1.png",
		this,
		menu_selector(CFlowLoseLayer::goToMenuLayer)
	);
	pGoMenu->setPosition(ccp(bg_size.width / 2, bg_size.height*0.6));
	CCMenuItemImage *pContinue = CCMenuItemImage::create(
		"overlayer/continue.png",
		"overlayer/continue_1.png",
		this,
		menu_selector(CFlowLoseLayer::goContinue)
	);
	pContinue->setPosition(ccp(bg_size.width / 2 , bg_size.height*0.4));
	m_pMenu = CCMenu::create(pReplay, pGoMenu, pContinue, NULL);
	m_pMenu->setPosition(Vec2(0, 0));
	pBGSprite->addChild(m_pMenu, 2);

	EventListenerTouchOneByOne *listener = EventListenerTouchOneByOne::create();
	listener->setSwallowTouches(true); //ݴ
	listener->onTouchBegan = CC_CALLBACK_2(CFlowLoseLayer::onTouchBegan, this);
	//
	Director::getInstance()->getEventDispatcher()->addEventListenerWithSceneGraphPriority(listener, this);
}
bool CFlowLoseLayer::onTouchBegan(CCTouch *pTouch, CCEvent *pEvent)
{
	return true;
}

void CFlowLoseLayer::replayGame(CCObject *pSender)
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	CCScene *m_gameScene = CCScene::create();
	CFlowGameLayer *gamelayer = CFlowGameLayer::create();
	m_gameScene->addChild(gamelayer);
	CCDirector::sharedDirector()->replaceScene(m_gameScene);
}

void CFlowLoseLayer::goToMenuLayer(CCObject *pSender)
{
	//CocosDenshion::SimpleAudioEngine::sharedEngine()->stopBackgroundMusic(true);
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		//CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	CFlowManagement *fm=new CFlowManagement;
	fm->goSectionSelectLayer();
}
void CFlowLoseLayer::goContinue(Object *pSender)
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		//CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	this->removeFromParent();
}
