#include "FlowMenuLayer.h"
//#include "curl/curl.h"
#include "SimpleAudioEngine.h"

#if(CC_TARGET_PLATFORM==CC_PLATFORM_ANDROID)
#include <jni.h>
#include "platform/android/jni/JniHelper.h"
#include <android/log.h>
#endif

CFlowMenuLayer::CFlowMenuLayer(void)
{
}


CFlowMenuLayer::~CFlowMenuLayer(void)
{
}

bool CFlowMenuLayer::init()
{
	if (!CCLayer::init())
	{
		return false;
	}
	setKeypadEnabled(true);   //÷ؼ
	CCSize visibleSize=CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();
	CCSprite *menuBackground=CCSprite::create("menulayer/bg_main_act.jpg");
	menuBackground->setPosition(ccp(origin.x+visibleSize.width/2,origin.y+visibleSize.height/2));
	this->addChild(menuBackground);

	//ʼؿ
	initUserData();

	CCMenuItemImage *toSelectSection=CCMenuItemImage::create(
		"menulayer/bg_play.png",
		"menulayer/bg_play_pressed.png",
		this,
		menu_selector(CFlowMenuLayer::goToSelectSectionLayer)
		);
	toSelectSection->setPosition(ccp(visibleSize.width/2,visibleSize.height/2-60));

	CCMenuItemImage *toMore=CCMenuItemImage::create(
		"menulayer/bg_more.png",
		"menulayer/bg_more_pressed.png",
		this,
		menu_selector(CFlowMenuLayer::goToMore)
		);
	toMore->setPosition(ccp(visibleSize.width/3-40,visibleSize.height/4));

	CCMenuItemImage *toRange=CCMenuItemImage::create(
		"menulayer/rank.png",
		"menulayer/rank_pressed.png",
		this,
		menu_selector(CFlowMenuLayer::goToRange)
		);
	toRange->setPosition(ccp(visibleSize.width/3*2+40,visibleSize.height/4));

	CCMenuItemImage *pet=CCMenuItemImage::create(
		"menulayer/pet0.png",
		"menulayer/pet1.png",
		this,
		menu_selector(CFlowMenuLayer::petShine)
		);
	pet->setPosition(ccp(visibleSize.width/2,visibleSize.height*0.1));

	m_pMenu=CCMenu::create(toSelectSection,toMore,toRange,pet,NULL);
	m_pMenu->setPosition(Vec2(0, 0));
	this->addChild(m_pMenu,2);


	return true;
}
void CFlowMenuLayer::initUserData()
{
	if (UserDefault::getInstance()->getIntegerForKey("flow_five_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_five_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_six_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_six_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_seven_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_seven_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_eight_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_eight_max_level", 1);
		UserDefault::getInstance()->flush();
	}
	if (UserDefault::getInstance()->getIntegerForKey("flow_nine_max_level") == 0) {
		UserDefault::getInstance()->setIntegerForKey("flow_nine_max_level", 1);
		UserDefault::getInstance()->flush();
	}
}

void CFlowMenuLayer::KeyBackClicked()
{
	CCDirector::sharedDirector()->end();  //ؼ˳Ϸ
}


void CFlowMenuLayer::goToSelectSectionLayer(CCObject *pSender)
{
	playSound();
    fm->goSelectSectionLayer();
}

void CFlowMenuLayer::goToMore(CCObject *pSender)
{
	playSound();
#if (CC_TARGET_PLATFORM==CC_PLATFORM_ANDROID)
	//CCApplication::sharedApplication()->openURL("http://app.easymobi.cn");
#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
	exit(0);
#else 
	//ShellExecuteA(NULL,"open","www.baidu.com",NULL,NULL,SW_SHOWNORMAL);
	CCDirector::sharedDirector()->end();
#endif
#endif
}

void CFlowMenuLayer::goToRange(CCObject *pSender)
{
	playSound();
//	CURL *curl;
//	CURLcode res;

//	curl = curl_easy_init();
//	if (curl) 
//	{
//		curl_easy_setopt(curl, CURLOPT_URL, "www.baidu.com");
//		res = curl_easy_perform(curl);
		/* always cleanup */
//		curl_easy_cleanup(curl);
//	}	

}

void CFlowMenuLayer::petShine(CCObject *pSender)
{
	playSound();
	CCSize visibleSize=CCDirector::sharedDirector()->getVisibleSize();
	CCSprite *sp=CCSprite::create("menulayer/pet0.png");
	sp->setPosition(ccp(visibleSize.width/2,visibleSize.height*0.1));
	addChild(sp);

	CCAnimation  *animation=CCAnimation::create();
	animation->addSpriteFrameWithFileName("menulayer/pet2.png");
	animation->addSpriteFrameWithFileName("menulayer/pet1.png");
	animation->addSpriteFrameWithFileName("menulayer/pet0.png");
	animation->setDelayPerUnit(0.5f/3);
	animation->setRestoreOriginalFrame(true);
	sp->runAction(CCAnimate::create(animation));
}


void CFlowMenuLayer::playSound()
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
			CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
}
