#include "FlowSelectLevelLayer.h"
#include "Mydata.h"
#include "SimpleAudioEngine.h"
#include"cocostudio/CocoStudio.h"
#include"UIUtils.h"
using namespace std;
extern int whichGame;
extern int sectionIndex;
extern int kindIndex;
extern int persentLevel;

FlowSelectLevelLayer::FlowSelectLevelLayer(void)
{
}
FlowSelectLevelLayer::~FlowSelectLevelLayer(void)
{
}
bool FlowSelectLevelLayer::init()
{
	if (!Layer::init()) {
		return false;
	}

	winSize = Director::getInstance()->getVisibleSize();


	Node * rootNode = CSLoader::createNode("selectlevel/selectLevelNode.csb");
	rootNode->setScale(0.75f);
	this->addChild(rootNode);

	ui::ScrollView* scrollView = FIND_NODE(ui::ScrollView*, rootNode, "ScrollView_1");
	scrollView->setScrollBarEnabled(false);
	scrollView->setClippingType(ui::ScrollView::ClippingType::SCISSOR);

	auto bg = FIND_NODE(Sprite*, rootNode, "bg_1");
	bg->setTexture("hallScene/hall_bg.png");

	auto layout = FIND_NODE(Layout *, rootNode, "panel_1");

	Text* text_1 = FIND_NODE(Text *, rootNode, "Text_1");
	Text* text_2 = FIND_NODE(Text *, rootNode, "Text_2");
	Text* text_3 = FIND_NODE(Text *, rootNode, "Text_3");
	Text* text_4 = FIND_NODE(Text *, rootNode, "Text_4");
	Text* text_5 = FIND_NODE(Text *, rootNode, "Text_5");

	if (whichGame == 0) {
		maxLevel = UserDefault::getInstance()->getIntegerForKey("flow_five_max_level");
		text_1->setVisible(true);
	}
	else if (whichGame == 1) {
		maxLevel = UserDefault::getInstance()->getIntegerForKey("flow_six_max_level");
		text_2->setVisible(true);
	}
	else if (whichGame == 2) {
		maxLevel = UserDefault::getInstance()->getIntegerForKey("flow_seven_max_level");
		text_3->setVisible(true);
	}
	else if (whichGame == 3) {
		maxLevel = UserDefault::getInstance()->getIntegerForKey("flow_eight_max_level");
		text_4->setVisible(true);
	}
	else if (whichGame == 4) {
		maxLevel = UserDefault::getInstance()->getIntegerForKey("flow_nine_max_level");
		text_5->setVisible(true);
	}	
	for (int i = 0; i < 5; i++)
	{
		for (int j = 0; j < 16; j++)
		{
			//Sprite* item = Sprite::create("selectlevel/item1.png");
			//item->setPosition(Vec2(100+100*i,-100*j+1150));
			//layout->addChild(item);
			int idx = i + j * 5 + 1;
			string sprite1, sprite2;
			if (maxLevel >= idx) {
				sprite1 = "selectlevel/item2.png";
				sprite2 = "selectlevel/item1.png";

				auto item4 = MenuItemImage::create(sprite2, sprite1, CC_CALLBACK_1(FlowSelectLevelLayer::menuCallback, this));
				item4->setPosition(Vec2(80 + 110 * i, -90 * j + 1430));
				item4->setTag(idx);
				auto menu = Menu::create(item4, NULL);
				menu->setAnchorPoint(Vec2::ZERO);
				menu->setPosition(Vec2::ZERO);
				layout->addChild(menu);

				//newʶ
				if (item4->getTag() == maxLevel)
				{
					Size menu_size = item4->getContentSize();
					Sprite* m_new = Sprite::create("selectlevel/new.png");
					m_new->setPosition(Vec2(menu_size.width - 10, menu_size.height - 10));
					item4->addChild(m_new);
				}
			}
			else {
				//sprite1 = "selectlevel/item1.png";
				sprite2 = "selectlevel/item2.png";
				Sprite* item4 = Sprite::create(sprite2);
				item4->setPosition(Vec2(80 + 110 * i, -90 * j + 1430));
				layout->addChild(item4);
			}

			Label* label = Label::createWithCharMap("selectlevel/num.png", 26, 43, '0');
			label->setString(toString((i + j * 5 + 1)));
			//label->setScale(0.75);
			label->setPosition(Vec2(80 + 110 * i, -90 * j + 1430));
			layout->addChild(label);
		}
	}

	initEvent();

	return true;
}

void FlowSelectLevelLayer::menuCallback(Ref* sender)
{
	MenuItem* menu = (MenuItem*)(sender);
	int tag = menu->getTag();
	//if (maxLevel >= tag)
	//{
		persentLevel = tag;
		//CCLOG("item.....%d", tag);
		changeIndex(whichGame, tag);
		fm->goGameLayer();
	//}	
}
void FlowSelectLevelLayer::changeIndex(int kind, int tag)
{
	//CCLOG("befor kind = %d, sectionSelect:%d",kindIndex,sectionIndex);
	switch (kind)
	{
	case 0:   //5*5ģʽ 1-20
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag - 20;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag - 40;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag - 60;
		}
	}
		break;
	case 1:  //6*6ģʽ  21-40
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag+20;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag-20;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag-40;
		}
	}
		break;
	case 2:  //7*7ģʽ 41-60
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag+40;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag+20;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag - 20;
		}
	}
		break;
	case 3:  //8*8ģʽ 61-80
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag+60;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag +40;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag + 20;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag;
		}
	}
		break;
	case 4:  //9*9ģʽ 81-100
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag+80;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag+60;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag+40;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag+20;
		}
	}
		break;
	default:
		break;
	}
	//CCLOG("after kind = %d, sectionSelect:%d", kindIndex, sectionIndex);
}

//void FlowSelectLevelLayer::onEnter()
//{
//	CCLayer::onEnter();
//	//CCDirector::sharedDirector()->getTouchDispatcher()->addTargetedDelegate(this,0,true);
//	EventListenerTouchOneByOne *listener = EventListenerTouchOneByOne::create();
//	listener->setSwallowTouches(true); //ݴ
//	listener->onTouchBegan = CC_CALLBACK_2(FlowSelectLevelLayer::onTouchBegan, this);
//	listener->onTouchMoved = CC_CALLBACK_2(FlowSelectLevelLayer::onTouchMoved, this);
//	listener->onTouchEnded = CC_CALLBACK_2(FlowSelectLevelLayer::onTouchEnded, this);
//	listener->onTouchCancelled = CC_CALLBACK_2(FlowSelectLevelLayer::onTouchCancelled, this);
//	//
//	Director::getInstance()->getEventDispatcher()->addEventListenerWithSceneGraphPriority(listener, this);
//

//}
//void FlowSelectLevelLayer::onExit() {
//	//CCDirector::sharedDirector()->getTouchDispatcher()->removeDelegate(this);
//	CCLayer::onExit();
//}
//bool FlowSelectLevelLayer::onTouchBegan(CCTouch *pTouch, CCEvent *pEvent) {
//	
//	return true;
//}
//void FlowSelectLevelLayer::onTouchMoved(CCTouch *pTouch, CCEvent *pEvent)
//{
//
//}
//void FlowSelectLevelLayer::onTouchEnded(CCTouch *pTouch, CCEvent *pEvent) {
//	
//
//}
//void FlowSelectLevelLayer::onTouchCancelled(CCTouch *pTouch, CCEvent *pEvent) {
//	
//
//}
void FlowSelectLevelLayer::initEvent() {
	//android back
	EventListenerKeyboard* l = EventListenerKeyboard::create();
	l->onKeyReleased = CC_CALLBACK_2(FlowSelectLevelLayer::onKeyReleased, this);
	_eventDispatcher->addEventListenerWithSceneGraphPriority(l, this);
}

void FlowSelectLevelLayer::goToGameLayer(CCObject *pSender)
{
	CCMenuItem *pMenuItem = (CCMenuItem *)pSender;
	int nIdx = pMenuItem->getZOrder();
	sectionIndex = nIdx;
	CCLOG("sectionSelect:%d", sectionIndex);
	fm->goGameLayer();
}

void FlowSelectLevelLayer::onKeyReleased(EventKeyboard::KeyCode keyCode, Event* event)
{
	switch (keyCode)
	{
		//ؼ       
	case EventKeyboard::KeyCode::KEY_ESCAPE:
	{
		onkeyBackClicked();
	}
	break;
	//menu        
	case EventKeyboard::KeyCode::KEY_MENU:
		break;
	}
}

void FlowSelectLevelLayer::onkeyBackClicked()
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	fm->goSelectSectionLayer();
}