#include "FlowWinLayer.h"
#include "FlowGameLayer.h"
#include "FlowSectionSelectLayer.h"
#include "FlowManagement.h"
#include "SimpleAudioEngine.h"
#include"cocostudio/CocoStudio.h"
#include"UIUtils.h"
#include"PlatformUtil.h"
extern int whichGame;
extern int sectionIndex;
extern int kindIndex;
extern int score;
extern int persentLevel;
CFlowWinLayer::CFlowWinLayer(void)
{
}


CFlowWinLayer::~CFlowWinLayer(void)
{
}


bool CFlowWinLayer::init()
{
	bool bRet=false;
	do 
	{
		CC_BREAK_IF(!CCLayerGradient::initWithColor(ccc4(0,0,0,0),ccc4(250,250,250,0),ccp(0,1)));
		this->initDialog();
		bRet=true;
	} while (0);
	return bRet;
}

void CFlowWinLayer::initDialog()
{
	xGetInsert(6);     //Ϸ

	CCSize visibleSize=CCDirector::sharedDirector()->getVisibleSize();
	CCPoint origin=CCDirector::sharedDirector()->getVisibleOrigin();

	node = CSLoader::createNode("blockgoOver/overNode.csb");
	node->setScale(0.75f);
	this->addChild(node);

	panel_over = FIND_NODE(Layout*, node, "panel_over");
	level = FIND_NODE(Text*, node, "level");
	timeLabel = FIND_NODE(Text*, node, "usetime");
	loading = FIND_NODE(ImageView*, node, "Image_1");
	text_2 = FIND_NODE(Text*, node, "Text_2");
	text_2->setVisible(false);

	char* but[3] = { "over_back","over_again","over_next" };

	for (int i = 0; i < 3; i++)
	{
		auto buts = INIT_BTN(node, but[i], CC_CALLBACK_1(CFlowWinLayer::dealButtonClick, this));
	}

	dealLoadingBar();

	CCString *pLevelStr = CCString::createWithFormat("%d", persentLevel);

}

void CFlowWinLayer::dealLoadingBar()
{
	int cout = GETINTEGER("flow_game_cout");
	if (cout == 0) {
		cout = 1;
	}
	if (cout == 10)
	{
		SimpleAudioEngine::getInstance()->playEffect("music/coin.mp3");
		//CREATE_EFFECT(Size(540, 960), 0, this);
		//ﵽͽҵ
		SETINTEGER("flow_game_cout", 0);
		SETINTEGER("gold_coin", GETINTEGER("gold_coin") + 20); //20
	}
	auto Lbar = LoadingBar::create("over/over_loading1.png");
	Lbar->setTag(100);
	Lbar->setPercent(cout * 10);
	Lbar->setPosition(loading->getPosition());
	Lbar->setDirection(LoadingBar::Direction::LEFT);
	panel_over->addChild(Lbar);

	Label* coutLabel = Label::createWithSystemFont("", "", 25);
	coutLabel->setString(toString(cout));
	coutLabel->setPosition(Vec2(loading->getPositionX() - 15, loading->getPositionY()));
	panel_over->addChild(coutLabel);

	Label* label1 = Label::createWithSystemFont("/10", "", 25);
	label1->setPosition(Vec2(loading->getPositionX() + 20, loading->getPositionY()));
	panel_over->addChild(label1);
}

void CFlowWinLayer::dealButtonClick(Ref* sender)
{
	auto but = (Button*)sender;
	auto butName = but->getName();
	if (butName == "over_back")
	{
		goToMenuLayer(NULL);
	}
	else if (butName == "over_again")
	{
		replayGame(NULL);
	}
	else if (butName == "over_next")
	{
		goToNextSection(NULL);
	}
}

void CFlowWinLayer::getData(int time, bool isWin, int levelnum)
{
	SimpleAudioEngine::getInstance()->playEffect("music/win.mp3", false);
	auto over_bg = FIND_NODE(Sprite*, node, "over_bg_1");
	auto over_lose = FIND_NODE(Sprite*, node, "over_win_2");
	if (!isWin) {
		text_2->setVisible(false);
		over_bg->setTexture("over/over_bg.png");
		over_lose->setTexture("over/over_lose.png");
	}
	else
	{
	}
	parentLevel = levelnum;

	int fen = (int)(time / 60);
	int miao = (int)((int)time % 60);
	string timeStr;
	timeStr = CCString::createWithFormat("%02d:%02d", fen, miao)->getCString();
	timeLabel->setString(toString(timeStr));
	level->setString(toString(levelnum));

}

void CFlowWinLayer::replayGame(CCObject *pSender)
{
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	CCScene *m_gameScene=CCScene::create();
	CFlowGameLayer *gamelayer=CFlowGameLayer::create();
	m_gameScene->addChild(gamelayer);
	CCDirector::sharedDirector()->replaceScene(m_gameScene);

}

void CFlowWinLayer::goToMenuLayer(CCObject *pSender)
{
	//CocosDenshion::SimpleAudioEngine::sharedEngine()->stopBackgroundMusic(true);
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		//CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	CFlowManagement *fm=new CFlowManagement;
	fm->goSectionSelectLayer();
}

void CFlowWinLayer::goToNextSection(CCObject *pSender)
{
	//sectionIndex++;
	persentLevel++;
	changeIndex(whichGame, persentLevel);
	CFlowManagement *fm=new CFlowManagement;
	if (CCUserDefault::sharedUserDefault()->getBoolForKey("isSoundOn"))
	{
		CocosDenshion::SimpleAudioEngine::sharedEngine()->playEffect("music/menu.mp3");
	}
	fm->goGameLayer();
}
void CFlowWinLayer::changeIndex(int kind, int tag)
{
	//CCLOG("befor kind = %d, sectionSelect:%d",kindIndex,sectionIndex);
	switch (kind)
	{
	case 0:   //5*5ģʽ 1-20
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag - 20;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag - 40;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag - 60;
		}
	}
	break;
	case 1:  //6*6ģʽ  21-40
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag + 20;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag - 20;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag - 40;
		}
	}
	break;
	case 2:  //7*7ģʽ 41-60
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag + 40;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag + 20;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag - 20;
		}
	}
	break;
	case 3:  //8*8ģʽ 61-80
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag + 60;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag + 40;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag + 20;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag;
		}
	}
	break;
	case 4:  //9*9ģʽ 81-100
	{
		if (tag <= 20) {
			kindIndex = 0;
			sectionIndex = tag + 80;
		}
		else if (tag <= 40) {
			kindIndex = 1;
			sectionIndex = tag + 60;
		}
		else if (tag <= 60) {
			kindIndex = 2;
			sectionIndex = tag + 40;
		}
		else if (tag <= 80) {
			kindIndex = 3;
			sectionIndex = tag + 20;
		}
	}
	break;
	default:
		break;
	}
}